//CsvTable.cpp
#include "CsvTable.h"
#include <fstream>
#include <vector>

template<int N>
class Context 
{
public:
	char str[N];

private:
	int size;
	int pos;

public:
	Context() : size(N), pos() {}

	//Ű  Ͽ ͸  
	std::string GetAndNext() 
	{
		char c[N] = {};
		int p = 0;
		for (int i = pos; i < size; i++, p++, pos++) 
		{
			if (str[i] == ',' || str[i] == '\0') 
			{
				pos++;
				return c;
			}
			c[p] = str[i];
		}
		return c;
	}

	void Reset() 
	{
		pos = 0;
		memset( str, 0, N );
	}
};

CsvTable::Variant CsvTable::Record::nullVariant;

CsvTable::Record::~Record() 
{

}

void CsvTable::Record::UnInit()
{
	std::map<std::string, Variant*>::iterator it;
	for (it = vals.begin(); it != vals.end(); it++)
		delete it->second;
}

CsvTable::Variant& CsvTable::Record::operator[](const char* key) 
{
	if (vals.find(key) == vals.end())
		return nullVariant;
	return *vals[key];
}

bool CsvTable::Record::IsNull( Variant *val )
{
	if( val == &nullVariant )
		return true;
	else
		return false;	
}

void CsvTable::Record::Add(const char* key, Variant &val) 
{
	if (vals.find(key) == vals.end())
		vals[key] = new Variant(val);
	else
		(*vals[key]) = val;
}


CsvTable::Record CsvTable::nullRecord;

CsvTable::~CsvTable() 
{
}

bool CsvTable::Init(const char* filePath, ColRowInfo* info ) 
{
	std::ifstream ifs(filePath);
	if( ifs.is_open() == false ) 
		return false;

	//  
	int col = 0, row = 0;
	char s[2048] = {};
	bool autoIndex = false;
	if( info == NULL )
	{
		ifs.getline(s, 2048);
		col = atoi(s);
		ifs.getline(s, 2048);
		row = atoi(s);
	}
	else
	{
		col = info->col;
		row = info->row;
		autoIndex = info->autoIndex;
		for( int m = 0; m < info->startRowIndex; ++m )
			ifs.getline(s, 2048);
	}

	// Ű ˻
	std::vector<std::string> dataKeys;
	Context<2048> ct;

	if( autoIndex )
	{
		char szText[30];
		for (int c = 0; c < col; c++)
		{
			memset( szText, 0, 30 );
			_itoa_s( c, szText, 30, 10 );
			dataKeys.push_back( szText );		
		}
	}
	else
	{
		ifs.getline(ct.str, 2048);
		for (int c = 0; c < col; c++)
			dataKeys.push_back( ct.GetAndNext() );
	}

	// ˻
	ct.Reset();
	for (int r = 0; r < row; r++) 
	{
		char szRowKey[30];
		ifs.getline(ct.str, 2048);
		Record *rec = new Record();

		std::string key;
		if( autoIndex )
		{
			memset( szRowKey, 0, 30 );
			_itoa_s( r, szRowKey, 30, 10 );
			key = szRowKey;
			for (int c = 0; c < col; c++) 
				rec->Add( dataKeys[c].c_str(), Variant(ct.GetAndNext()) );
		}
		else
		{
			key = ct.GetAndNext();
			for (int c = 1; c < col; c++) 
				rec->Add( dataKeys[c].c_str(), Variant(ct.GetAndNext()) );
		}

		records[key] = rec;
		ct.Reset();
	}

	return true;
}

void CsvTable::UnInit() 
{
	std::map<std::string, Record*>::iterator it;
	for (it = records.begin(); it != records.end(); it++)
	{
		it->second->UnInit();
		delete it->second;
	}
	records.clear();
}

CsvTable::Record& CsvTable::operator[](const char* key) 
{
	if (records.find(key) == records.end())
		return nullRecord;
	return *records[key];
}

bool CsvTable::IsNull( Record* record )
{
	if( record == &nullRecord )
		return true;
	else
		return false;
}