//CsvTable.h
#ifndef __CSVTABLE_H
#define __CSVTABLE_H

#include <string>
#include <map>

class CsvTable 
{
public:
	struct ColRowInfo
	{
		int col;
		int row;
		int startRowIndex;
		bool autoIndex;

		ColRowInfo( int _col, int _row, int _startRowIndex, bool _autoIndex = false )
			: col( _col )
			, row( _row )
			, startRowIndex( _startRowIndex )
			, autoIndex( _autoIndex )
		{
		}
	};

	struct Variant 
	{
		std::string str;
		int iVal;
		float fVal;
		Variant() : iVal(), fVal() 
		{}

		Variant(const std::string &s) 
			: iVal(atoi(s.c_str()))
			, fVal((float)atof(s.c_str()))
			, str(s) 
		{
		}

		operator std::string() 
		{
			return str;
		}

		operator int() 
		{
			return iVal;
		}

		operator float() 
		{
			return fVal;
		}
	};

	class Record 
	{
	private:
		std::map<std::string, Variant*> vals;
		static Variant nullVariant;

	public:
		Record() {}
		~Record();
		void UnInit();
		CsvTable::Variant& operator [](const char* key);
		//NULL  üũ ҷ operator   Ͻ  ޾ƾ Ѵ.
		bool IsNull( Variant* val );
		void Add(const char* key, Variant &val);
	};

private:
	CsvTable(const CsvTable &src);
	CsvTable& operator =(const CsvTable &src);

protected:
	static Record nullRecord;
	std::map<std::string, Record*> records;

public:
	CsvTable()
	{
	}
	virtual ~CsvTable();

	bool Init(const char* filePath, ColRowInfo* colRow = NULL );
	void UnInit();

	Record& operator[](const char* key);
	//NULL  üũ ҷ operator   Ͻ  ޾ƾ Ѵ.
	bool IsNull( Record* record );
};


#endif
