#include <conio.h>
#include "CsvTable.h"

// : http://marupeke296.com/NGDV_No2_CSVTable.html

void output( CsvTable &table, const char* id) 
{
	CsvTable::Record &record = table[id];

	printf("%s\t %s\t %d\t %d\t %d\n",
                record["name"].str.c_str(),
                record["attribute"].str.c_str(),
                record["price"].iVal,
                record["attack"].iVal,
                record["defence"].iVal
        );
}

void main()
{
	{
		CsvTable table;
		//table.Init( "test.csv", &CsvTable::ColRow( 6, 3, 2 ) );
		table.Init("test.csv");
		table.Init( "test.csv", &CsvTable::ColRowInfo( 6, 6, 0, true ) );
	

		printf( "name\t attrib\t price\t attack\t defence\n" );
		output(table, "item_w_0001");
		output(table, "item_w_0002");
		output(table, "item_w_0003");

		//null ˻
		CsvTable::Record &record = table["item_w_0003"];
		bool bNull1 = table.IsNull( &record );
		if( bNull1 == false )
		{
			CsvTable::Variant& var = record["engname"]; 
			bool bNull2 = record.IsNull( &var );
			if( bNull2 == true )
				printf( "\n\ntable[\"item_w_0003\"][\"engname\"] is null\n" );
		}

		const char* name = table["item_w_0003"]["name"].str.c_str();
		printf( "table[\"item_w_0003\"][\"name\"] is %s\n", name );
		table.UnInit();
	}

	{
		printf( "=====================================================\n" );
		CsvTable table;
		table.Init( "test.csv", &CsvTable::ColRowInfo( 6, 6, 0, true ) );
	
		char szText1[100], szText2[100];
		for( int m = 0; m < 6; ++m )
		{
			for( int n = 0; n < 6; ++n )
			{
				_itoa_s( m, szText1, 100, 10 );
				_itoa_s( n, szText2, 100, 10 );
				printf( "table[%d][%d] is %s\n", m, n, table[szText1][szText2].str.c_str() );	
			}
		}

		const char* name = table["3"]["0"].str.c_str();
		printf( "\ntable[\"3\"][\"0\"] is %s\n", name );
		table.UnInit();

	}
	_getch();
}

